=== debian/changelog ===
ros-crystal-rcutils (0.6.2-0bionic) bionic; urgency=high

  * Adding an ArrayList and HashMap implementation to rcutils (#131 <https://github.com/ros2/rcutils/issues/131>)
  * Change uncrustify max line length to 0 (#133 <https://github.com/ros2/rcutils/issues/133>)
  * Contributors: Jacob Perron, Nick Burek

 -- Karsten Knese <karsten@osrfoundation.org>  Thu, 07 Feb 2019 08:00:00 -0000

ros-crystal-rcutils (0.6.1-0bionic) bionic; urgency=high

  * Logging (#127 <https://github.com/ros2/rcutils/issues/127>)
  * fixes to support including in c++ and fetch_add (#129 <https://github.com/ros2/rcutils/issues/129>)
  * reiterate over char array (#130 <https://github.com/ros2/rcutils/issues/130>)
  * add rcutils_unsigned_char_array_t (#125 <https://github.com/ros2/rcutils/issues/125>)
  * Contributors: Karsten Knese, Nick Burek, William Woodall

 -- Karsten Knese <karsten@osrfoundation.org>  Thu, 06 Dec 2018 08:00:00 -0000

ros-crystal-rcutils (0.6.0-0bionic) bionic; urgency=high

  * Added rcutils_to_native_path function (#119 <https://github.com/ros2/rcutils/issues/119>)
  * Moved stdatomic helper to rcutils (#126 <https://github.com/ros2/rcutils/issues/126>)
  * Fixed warning in release build due to assert (#124 <https://github.com/ros2/rcutils/issues/124>)
  * Updated to avoid dynamic memory allocation during error handling (#121 <https://github.com/ros2/rcutils/issues/121>)
  * Added macro semicolons (#120 <https://github.com/ros2/rcutils/issues/120>)
  * Added LL suffix to avoid c4307 (#118 <https://github.com/ros2/rcutils/issues/118>)
  * Updated to use the same allocator to free allocated message (#115 <https://github.com/ros2/rcutils/issues/115>)
  * Renamed rcutils_serialized_message -> rcutils_char_array (#111 <https://github.com/ros2/rcutils/issues/111>)
  * Moved serialized_message from rmw (#110 <https://github.com/ros2/rcutils/issues/110>)
  * Updated to verify that the requested allocation size does not overflow. (#109 <https://github.com/ros2/rcutils/issues/109>)
  * Contributors: Chris Lalancette, Jacob Perron, Karsten Knese, Mikael Arguedas, Ruffin, Shane Loretz, Todd Malsbary, William Woodall

 -- Karsten Knese <karsten@osrfoundation.org>  Fri, 16 Nov 2018 08:00:00 -0000

ros-crystal-rcutils (0.5.1-0bionic) bionic; urgency=high

  * Removed redundant stat() call (#108 <https://github.com/ros2/rcutils/pull/108>)

 -- Karsten Knese <karsten@osrfoundation.org>  Thu, 28 Jun 2018 07:00:00 -0000

ros-crystal-rcutils (0.5.0-0bionic) bionic; urgency=high

  * Audited use of malloc/realloc/calloc/free to make sure it always goes through an ``rcutils_allocator_t`` (#102 <https://github.com/ros2/rcutils/issues/102>)
  * Added ability to include a timestamp when a console logging message happens (#85 <https://github.com/ros2/rcutils/issues/85>)
  * Updated to use new memory_tools from osrf_testing_tools_cpp (#101 <https://github.com/ros2/rcutils/issues/101>)
  * Fixed a possible bug by preventing the default logger's level from being unset (#106 <https://github.com/ros2/rcutils/issues/106>)
  * Updated to use launch.legacy instead of launch (now used for new launch system) (#105 <https://github.com/ros2/rcutils/issues/105>)
  * Fixed a memory check issue in ``split.c`` (#104 <https://github.com/ros2/rcutils/issues/104>)
    * Signed-off-by: testkit <mailto:cathy.shen@intel.com>
  * Added ``RCUTILS_CONSOLE_STDOUT_LINE_BUFFERED`` to control flusing of output from the default output handler of the logging macros. (#98 <https://github.com/ros2/rcutils/issues/98>)
  * Can now control shared/static linking via BUILD_SHARED_LIBS (#94 <https://github.com/ros2/rcutils/issues/94>)
  * Addressed some MISRA C compliance issues (#91 <https://github.com/ros2/rcutils/issues/91>)
  * Fixed a steady time overflow issue (#87 <https://github.com/ros2/rcutils/issues/87>)
  * Changed rcutils_time_point_value_t type from uint64_t to int64_t (#84 <https://github.com/ros2/rcutils/issues/84>)
  * Fixed out-of-bounds read issue (#83 <https://github.com/ros2/rcutils/issues/83>)
    * Signed-off-by: Ethan Gao <mailto:ethan.gao@linux.intel.com>
  * Contributors: Dirk Thomas, Ethan Gao, Michael Carroll, Mikael Arguedas, Sagnik Basu, Shane Loretz, William Woodall, cshen, dhood, serge-nikulin

 -- Karsten Knese <karsten@osrfoundation.org>  Wed, 20 Jun 2018 07:00:00 -0000
